unit misc;

interface
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
type
  string8 = string[8];
TProgressNotify = procedure (Sender: TObject; Position: integer; var Break: boolean) of object;

procedure showTaskbar;
procedure hideTaskbar;
Procedure ShowStartButton;
Procedure HideStartButton;

Procedure restartwindows(wait:boolean);
procedure shutdowncomputer(wait:boolean);
procedure logoutwindows(wait:boolean);


Function Byte2Bin(byTemp : Byte) : String8;
Function checkbit(b : Byte; size : Byte; Var temp) : Boolean; {1-32}
Procedure setbit(b : Byte; onoff : Boolean; size : Byte; Var temp); {1-32}
Function tobigger(i:extended):longint;
Function BoundByte(min,max,value:longint):byte;
function ProportionalSize(phisicalsize,newsize:tpoint):Tpoint;

implementation
Const
{ Used to convert the Bit value to the actual corresponding number }
   bit : Array[1..32] of LongInt =
       (1, 2, 4, 8, $10, $20, $40, $80, $100, $200, $400, $800, $1000, $2000,
        $4000, $8000, $10000, $20000, $40000, $80000, $100000, $200000,
        $400000, $800000, $1000000, $2000000, $4000000, $8000000, $10000000,
        $20000000, $40000000, $80000000);
{b is which bit to set(1-32), size is the size of temp.
Use  SIZEOF(TEMP) to get the value, and temp is the actuall Integer based
number
returns True if bit set, False if not}
Function tobigger(i:extended):longint;
var
  t:longint;
begin
  t:=trunc(i);
  if t<>i then
   if i>0 then t:=t+1
   else t:=t-1;
  result:=t;
end;

function boundbyte(min,max,value:integer):byte;
begin
  if value<min then result:=min
  else
  if value>max then result:=max
  else result:=value;
end;

function ProportionalSize(phisicalsize,newsize:tpoint):Tpoint;
var
  Percent      : Byte;
  tempx,tempy  : Single;
begin
  if phisicalsize.x<>0 then
    tempx:=((newsize.x)/phisicalsize.x)*100
  else tempx:=0;
  If Phisicalsize.y<>0 then
    tempy:=((newsize.y)/phisicalsize.y)*100
  else Tempy:=0;
  if tempx<=tempy then
    percent:=trunc(tempx)
  else
    percent:=trunc(tempy);
  result.x:=trunc((phisicalsize.x/100)*percent);
  result.y:=trunc((phisicalsize.y/100)*percent);
end;

Procedure HideStartButton;
Var
  taskbarhandle,
  buttonhandle : HWND;
begin
  taskbarhandle := FindWindow('Shell_TrayWnd', nil);
  buttonhandle := GetWindow(taskbarhandle, GW_CHILD);
  ShowWindow(buttonhandle, SW_HIDE);
end;

Procedure ShowStartButton;
Var
  taskbarhandle,
  buttonhandle : HWND;
begin
  taskbarhandle := FindWindow('Shell_TrayWnd', nil);
  buttonhandle := GetWindow(taskbarhandle, GW_CHILD);
  ShowWindow(buttonhandle, SW_restore);
end;

//Function to round a real number to nearest bigger number;
//here starts some system routines with the wait variable wich determines
// if the sytem will give time to running applications to close normally or
// it forces the action without letting the user desit if it is safe to take this
// action.
//Restart the computer using the widnows restart functions
Procedure restartwindows(wait:boolean);
var
  fl:longint;
begin
  if wait then fl:=ewx_reboot
  else fl:=ewx_reboot and ewx_force;
  exitwindowsex(fl,0);
end;
//Shutdown the comopouter
procedure shutdowncomputer(wait:boolean);
var
  fl:longint;
begin
  if wait then fl:=ewx_shutdown
  else fl:=ewx_shutdown and ewx_force;
  exitwindowsex(fl,0);
end;
//Logoff current user and ask for loggin a new one
Procedure logoutwindows(wait:boolean);
var
  fl:longint;
begin
  if wait then fl:=ewx_logoff
  else fl:=ewx_logoff and ewx_force;
  exitwindowsex(fl,0);
end;

procedure hideTaskbar;
var wndHandle : THandle;
    wndClass  : array[0..50] of Char;
begin
 StrPCopy(@wndClass[0], 'Shell_TrayWnd');
 wndHandle := FindWindow(@wndClass[0], nil);
 ShowWindow(wndHandle, SW_HIDE); // This hides the taskbar
end;

procedure showTaskbar;
var wndHandle : THandle;
    wndClass  : array[0..50] of Char;
begin
 StrPCopy(@wndClass[0], 'Shell_TrayWnd');
 wndHandle := FindWindow(@wndClass[0], nil);
 ShowWindow(wndHandle, SW_RESTORE); // This restores the taskbar
end;

Function Byte2Bin(byTemp : Byte) : String8;
Var
  Count : Integer;
begin
  Byte2Bin[0] := #8;
  For Count := 0 to 7 do
    Byte2Bin[8 - Count] := Char(((byTemp shr Count) and 1) + ord('0'));
end;

Function checkbit(b : Byte; size : Byte; Var temp) : Boolean; {1-32}
Var
  c : Boolean;
begin
   c:=False;
   Case size of
     1 : c := Byte(temp) and bit[b] <> 0;     {Byte,shortint}
     2 : c := Word(temp) and bit[b] <> 0;     {Word,Integer}
     4 : c := LongInt(temp) and bit[b] <> 0;  {LongInt}
     else
      showmessage('Invalid size');
   end;
   result := c;
end;

{b,size,and temp same as above.  if onoff =True the bit will be set,
else the bit will be cleared}

Procedure setbit(b : Byte; onoff : Boolean; size : Byte; Var temp); {1-32}
begin
   if onoff then
   Case size of
     1 : Byte(temp) := Byte(temp) or bit[b];        {Byte}
     2 : Word(temp) := Word(temp) or bit[b];        {Word}
     4 : LongInt(temp) := LongInt(Temp) or bit[b];  {LongInt}
     else
       showmessage('Invalid size');
   end
   else
   Case size of
     1 : Byte(temp) := Byte(temp) and not bit[b];   {Byte}
     2 : Word(temp) := Word(temp) and not bit[b];   {Word}
     4 : LongInt(temp) := LongInt(Temp) and not bit[b];{LongInt}
     else
       showmessage('Invalid size');
   end;
end;
end.
